uniform sampler2D texture;
uniform int pass;
uniform float width;
uniform float height;


// dlł͈ȉŔzł͂cȂ񂾂ǁAnvidianۂ̂Œ 
// const float weight[8] = float[8](0.1284, 0.1221, 0.1051, 0.0819, 0.0577, 0.0368, 0.0212, 0.0111);

const float s = 2.0;
const float weight0 = 0.1284*s;
const float weight1 = 0.1221*s;
const float weight2 = 0.1051*s;
const float weight3 = 0.0819*s;
const float weight4 = 0.0577*s;
const float weight5 = 0.0368*s;
const float weight6 = 0.0212*s;
const float weight7 = 0.0111*s;

vec4 get_bothside_color(vec2 coord, float w)
{
  return (texture2D(texture, gl_TexCoord[0].st+coord)+texture2D(texture, gl_TexCoord[0].st-coord))*vec4(w);
}


// cu[ 
void pass1()
{
  vec4 color = texture2D(texture, gl_TexCoord[0].st)*vec4(weight0);
  color+=get_bothside_color(vec2(0.0, 1.0/height), weight1);
  color+=get_bothside_color(vec2(0.0, 2.0/height), weight2);
  color+=get_bothside_color(vec2(0.0, 3.0/height), weight3);
  color+=get_bothside_color(vec2(0.0, 4.0/height), weight4);
  color+=get_bothside_color(vec2(0.0, 5.0/height), weight5);
  color+=get_bothside_color(vec2(0.0, 6.0/height), weight6);
  color+=get_bothside_color(vec2(0.0, 7.0/height), weight7);
  gl_FragColor = color;
}


// u[ 
void pass2()
{
  vec4 color = texture2D(texture, gl_TexCoord[0].st)*vec4(weight0);
  color+=get_bothside_color(vec2(1.0/width, 0.0), weight1);
  color+=get_bothside_color(vec2(2.0/width, 0.0), weight2);
  color+=get_bothside_color(vec2(3.0/width, 0.0), weight3);
  color+=get_bothside_color(vec2(4.0/width, 0.0), weight4);
  color+=get_bothside_color(vec2(5.0/width, 0.0), weight5);
  color+=get_bothside_color(vec2(6.0/width, 0.0), weight6);
  color+=get_bothside_color(vec2(7.0/width, 0.0), weight7);
  gl_FragColor = color;
}

void main()
{
  if(pass==1) {
    pass1();
  }
  else if(pass==2) {
    pass2();
  }
}
